//vector.h

#ifndef VECTOR_H
#define VECTOR_H

class Vector{
  // class members
    double* pA; 
    int nRows;
    void memoryCheck();

public:

    //constructors and destructor

    Vector(int r, double* pa);//constructor 
    Vector(int r=0, double b=0.);//default constructor 
    Vector(double* pa, int low, int up);
    Vector(int r, int i);//elementary vectors
    Vector(const Vector& v);
    ~Vector();

    //overloaded operators
    Vector& operator=(const Vector& v);
    Vector& operator-=(const Vector& v);
    Vector operator*(double b);
    double operator[](int i){
      return pA[i];
    }

    //utilities and accessors
    double dotProd(const Vector& v);
    void printVec();
    int getNRows(){return nRows;}

    //friends
    friend class Matrix;
    friend class LRT;
};

Vector operator*(double b, const Vector& v);

#endif
